#---------------------------------------------------------
# This Datapack was made by CommandGeek
# Please do not copy or credit this as your own work!
# Youtube: www.youtube.com/CommandGeek
#---------------------------------------------------------

# Use Carrot on a stick
execute as @a[scores={IdeaUseCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:1}}}] run function 8_ideas:fish/equip
execute as @a[scores={IdeaUseCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:2}}}] run function 8_ideas:pickaxe/equip
execute as @a[scores={IdeaUseCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:3}}}] at @s anchored eyes run function 8_ideas:teleport/teleport
scoreboard players set @a[scores={IdeaUseCarrot=1..}] IdeaUseCarrot 0

# Fridge

execute as @e[tag=spawn_fridge] at @s positioned ~ ~0.5 ~ if block ~ ~ ~ air if block ~ ~1 ~ air run function 8_ideas:fridge/spawn
execute at @e[tag=spawn_fridge] positioned ~ ~0.5 ~ run function 8_ideas:fridge/kill

kill @e[tag=spawn_fridge]
execute as @e[tag=idea_fridge] at @s if block ~ ~-1 ~ air run function 8_ideas:fridge/kill
execute as @e[tag=fridge_door] at @s unless block ~ ~ ~ barrier run kill @s
execute as @e[tag=fridge_food] at @s unless block ~ ~2 ~ barrier run kill @s
execute at @e[tag=idea_fridge] run fill ~ ~ ~ ~ ~1 ~ minecraft:barrier replace air


execute at @a[scores={IdeaLeftover=1..,IdeaSneak=1..},nbt={OnGround:1b}] run particle poof ~ ~ ~ 1 1 1 0.2 50
execute at @a[scores={IdeaLeftover=1..,IdeaSneak=1..},nbt={OnGround:1b}] run summon minecraft:fireball ~ ~ ~ {Motion:[0.0d,-1.0d,0.0d],ExplosionPower:1}
scoreboard players remove @a[scores={IdeaLeftover=1..}] IdeaLeftover 1
scoreboard players set @a[scores={IdeaSneak=1..}] IdeaSneak 0
execute at @a[scores={IdeaLeftover=1..}] run particle minecraft:effect ~ ~ ~ .5 .5 .5 1 1

# Door
execute as @e[tag=!2,tag=idea_fridge,nbt=!{ArmorItems:[{},{},{},{id:"minecraft:orange_dye",tag:{CustomModelData:1}}]}] at @s unless entity @s[tag=open] run playsound block.iron_door.close master @a ~ ~ ~ 1 1
execute as @e[tag=!2,tag=idea_fridge,nbt=!{ArmorItems:[{},{},{},{id:"minecraft:orange_dye",tag:{CustomModelData:1}}]}] at @s unless entity @s[tag=open] run data modify entity @s ArmorItems[3] set value {id:"orange_dye",Count:1b,tag:{CustomModelData:1}}

execute as @e[tag=!2,tag=idea_fridge,nbt=!{ArmorItems:[{},{},{},{id:"minecraft:orange_dye",tag:{CustomModelData:2}}]}] at @s if entity @s[tag=open] run playsound block.iron_door.open master @a ~ ~ ~ 1 1
execute as @e[tag=!2,tag=idea_fridge,nbt=!{ArmorItems:[{},{},{},{id:"minecraft:orange_dye",tag:{CustomModelData:2}}]}] at @s if entity @s[tag=open] run data modify entity @s ArmorItems[3] set value {id:"orange_dye",Count:1b,tag:{CustomModelData:2}}
#    
execute as @e[tag=2,tag=idea_fridge,nbt=!{ArmorItems:[{},{},{},{id:"minecraft:orange_dye",tag:{CustomModelData:3}}]}] at @s unless entity @s[tag=open] run playsound block.iron_door.close master @a ~ ~ ~ 1 1
execute as @e[tag=2,tag=idea_fridge,nbt=!{ArmorItems:[{},{},{},{id:"minecraft:orange_dye",tag:{CustomModelData:3}}]}] at @s unless entity @s[tag=open] run data modify entity @s ArmorItems[3] set value {id:"orange_dye",Count:1b,tag:{CustomModelData:3}}

execute as @e[tag=2,tag=idea_fridge,nbt=!{ArmorItems:[{},{},{},{id:"minecraft:orange_dye",tag:{CustomModelData:4}}]}] at @s if entity @s[tag=open] run playsound block.iron_door.open master @a ~ ~ ~ 1 1
execute as @e[tag=2,tag=idea_fridge,nbt=!{ArmorItems:[{},{},{},{id:"minecraft:orange_dye",tag:{CustomModelData:4}}]}] at @s if entity @s[tag=open] run data modify entity @s ArmorItems[3] set value {id:"orange_dye",Count:1b,tag:{CustomModelData:4}}

# Item Catch
execute as @e[tag=fridge_food] at @s if entity @e[type=item,distance=..1.5,tag=!not_food] run function 8_ideas:fridge/food
    
# Item Freezing
execute as @e[tag=fridge_food] at @s positioned ~ ~1 ~ if data entity @s ArmorItems[3].id if entity @e[tag=idea_fridge,distance=..1,tag=!open] run function 8_ideas:fridge/freeze
execute as @e[tag=fridge_food,scores={IdeaFridgeTime=300..}] run function 8_ideas:fridge/convert
execute as @e[tag=fridge_food] unless data entity @s ArmorItems[3].id run scoreboard players set @s IdeaFridgeTime 0
scoreboard players set @e[tag=fridge_food,nbt={ArmorItems:[{},{},{},{id:"minecraft:carrot",tag:{CustomModelData:1}}]}] IdeaFridgeTime 0

# Finished Foot
execute as @e[tag=fridge_food,nbt={ArmorItems:[{},{},{},{id:"minecraft:carrot",tag:{CustomModelData:1}}]}] at @s positioned ~ ~1 ~ if entity @a[distance=..0.6] run give @p[distance=..0.6] minecraft:carrot{CustomModelData:1,display:{Name:'{"text":"Leftovers","italic":"false"}'}}
execute as @e[tag=fridge_food,nbt={ArmorItems:[{},{},{},{id:"minecraft:carrot",tag:{CustomModelData:1}}]}] at @s positioned ~ ~1 ~ if entity @a[distance=..0.6] run data modify entity @s ArmorItems[3] set value {}

# Click Detection
# execute as @e[tag=fridge_door] run data modify entity @s Age set value -6000
effect give @e[tag=fridge_door] invisibility 1000000 1 true
team join IdeaNoCol @e[tag=fridge_door,team=!IdeaNoCol]

# scoreboard players add @e[tag=fridge_door,scores={IdeaFridgeTime=..10}] IdeaFridgeTime 1
# execute as @e[tag=fridge_door,scores={IdeaFridgeTime=9}] run data modify entity @s Age set value 1

execute as @a at @s at @e[tag=idea_fridge,limit=1,sort=nearest] run playsound minecraft:fridge block @s ~ ~ ~ 0.7 1

# =========================================================================================

# Fish


execute as @a[scores={IdeaTakeDamage=1..},nbt={Inventory:[{Slot:103b,id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:1}}]}] at @s anchored eyes run function 8_ideas:fish/spawn
scoreboard players set @a[scores={IdeaTakeDamage=1..}] IdeaTakeDamage 0
effect give @a[nbt={Inventory:[{Slot:103b,id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:1}}]}] minecraft:water_breathing 1 255 true

effect give @e[tag=idea_fish] minecraft:resistance 1000000 255 true
scoreboard players add @e[tag=idea_fish] IdeaFishTime 1
execute as @e[tag=idea_fish,scores={IdeaFishTime=30..}] if predicate 8_ideas:fish/kill at @s run tp @s ~ -500 ~
    
# ==========================================================================================

# Door Spawn

execute as @e[tag=new_door] at @s run function 8_ideas:door/spawn
execute as @e[tag=idea_door,tag=!close] at @s if block ~ ~ ~ acacia_trapdoor[open=false] run function 8_ideas:door/close
execute as @e[tag=idea_door,tag=!close] at @s if block ~ ~1 ~ acacia_trapdoor[open=false] run function 8_ideas:door/close
execute as @e[tag=idea_door,tag=close] at @s if block ~ ~ ~ acacia_trapdoor[open=true] run function 8_ideas:door/open
execute as @e[tag=idea_door,tag=close,nbt=!{Rotation:[90f,0f]},nbt=!{Rotation:[180f,0f]},nbt=!{Rotation:[-90f,0f]}] at @s if block ~ ~ ~-1 acacia_trapdoor[open=true] run function 8_ideas:door/open
execute as @e[tag=idea_door,tag=close,nbt={Rotation:[90f,0f]}] at @s if block ~1 ~ ~ acacia_trapdoor[open=true] run function 8_ideas:door/open
execute as @e[tag=idea_door,tag=close,nbt={Rotation:[180f,0f]}] at @s if block ~ ~ ~1 acacia_trapdoor[open=true] run function 8_ideas:door/open
execute as @e[tag=idea_door,tag=close,nbt={Rotation:[-90f,0f]}] at @s if block ~-1 ~ ~ acacia_trapdoor[open=true] run function 8_ideas:door/open

execute as @e[tag=idea_door,tag=!close] at @s unless block ~ ~ ~ minecraft:acacia_trapdoor run function 8_ideas:door/kill
execute as @e[tag=idea_door,tag=!close] at @s unless block ~ ~1 ~ minecraft:acacia_trapdoor run function 8_ideas:door/kill

execute as @e[tag=idea_door,tag=close] at @s unless block ~ ~ ~ acacia_trapdoor run function 8_ideas:door/kill
execute as @e[tag=idea_door,tag=close,nbt=!{Rotation:[90f,0f]},nbt=!{Rotation:[180f,0f]},nbt=!{Rotation:[-90f,0f]}] at @s unless block ~ ~ ~-1 acacia_trapdoor run function 8_ideas:door/kill
execute as @e[tag=idea_door,tag=close,nbt={Rotation:[90f,0f]}] at @s unless block ~1 ~ ~ acacia_trapdoor run function 8_ideas:door/kill
execute as @e[tag=idea_door,tag=close,nbt={Rotation:[180f,0f]}] at @s unless block ~ ~ ~1 acacia_trapdoor run function 8_ideas:door/kill
execute as @e[tag=idea_door,tag=close,nbt={Rotation:[-90f,0f]}] at @s unless block ~-1 ~ ~ acacia_trapdoor run function 8_ideas:door/kill

# ===========================================================================================

# Base in a Box

execute at @e[tag=idea_base,tag=!used_base] run function 8_ideas:base/particle
execute as @e[tag=new_base] run data modify entity @s ArmorItems[3] set value {id:"ghast_spawn_egg",Count:1b,tag:{CustomModelData:3}}
execute at @e[tag=new_base] run playsound minecraft:block.wood.place master @a ~ ~ ~ 1 0.8
execute at @e[tag=new_base] run setblock ~ ~ ~ jack_o_lantern
tag @e[tag=new_base] remove new_base

execute as @e[tag=idea_base] at @s if block ~ ~1 ~ #minecraft:buttons[powered=true] run function 8_ideas:base/load
execute as @e[tag=idea_base,tag=used_base] at @s unless block ~ ~ ~ jack_o_lantern run function 8_ideas:base/save
execute as @e[tag=idea_base] at @s unless block ~ ~ ~ jack_o_lantern run summon item ~ ~ ~ {Item:{id:"ghast_spawn_egg",Count:1b,tag:{CustomModelData:3,display:{Name:'{"text":"Base in a Box","italic":"false"}'},EntityTag:{id:"armor_stand",Small:1b,Invisible:1b,Tags:["idea_base","new_base"],Marker:1b,Rotation:[0.0f,0.0f]}}}}
execute as @e[tag=idea_base] at @s unless block ~ ~ ~ jack_o_lantern run kill @e[type=item,nbt={Item:{id:"minecraft:jack_o_lantern"}},limit=1,sort=nearest]
execute as @e[tag=idea_base] at @s unless block ~ ~ ~ jack_o_lantern run kill @s
    
# =============================================================================================

# Pickaxe Hat

execute as @a store result score @s IdeaRotation run data get entity @s Rotation[1]
execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:2}}]},scores={IdeaRotation=90},tag=!used_mine] at @s run function 8_ideas:pickaxe/mine
tag @a[tag=used_mine,scores={IdeaRotation=..40}] remove used_mine

# ==============================================================================================

# Tall Farming

execute as @e[tag=idea_farm,scores={IdeaFarmCrop=1..}] at @s run function 8_ideas:farm/grow
execute as @e[tag=spawn_farm] at @s unless block ~ ~ ~ farmland run advancement grant @p only 8_ideas:farm/craft
execute as @e[tag=spawn_farm] at @s unless block ~ ~ ~ farmland run kill @s
execute as @e[tag=spawn_farm] at @s align y positioned ~ ~1 ~ run setblock ~ ~ ~ wheat[age=0]
execute as @e[tag=spawn_farm] at @s align y positioned ~ ~1 ~ run function 8_ideas:farm/spawn

execute as @e[tag=idea_farm] at @s unless block ~ ~ ~ wheat unless block ~ ~ ~ air run tag @s add kill_farm
execute as @e[tag=idea_farm] at @s run function 8_ideas:farm/raycast
execute as @e[tag=farm_ex] at @s unless block ~ ~ ~ farmland positioned ~ ~-1 ~ unless entity @e[tag=farm_ex,distance=..0.1] run kill @s

# ===============================================================================================

# Cookie Gun
        
execute as @e[type=minecraft:firework_rocket] if data entity @s FireworksItem.tag.Cookie run kill @s
    
execute at @e[tag=idea_cookie,nbt={OnGround:1b},scores={IdeaCookieTime=5..}] run summon item ~ ~ ~ {Item:{id:"cookie",Count:1b}}
kill @e[tag=idea_cookie,nbt={OnGround:1b},scores={IdeaCookieTime=5..}]
scoreboard players add @e[tag=idea_cookie] IdeaCookieTime 1

execute as @a[nbt={SelectedItem:{tag:{Cookie:1b}}}] unless data entity @s SelectedItem.tag.ChargedProjectiles[] run replaceitem entity @s weapon.mainhand crossbow{ChargedProjectiles:[{id:"firework_rocket",Count:1b,tag:{Cookie:1b,CustomModelData:1}}],Charged:1b,display:{Name:'{"text":"Cookie Blaster","italic":"false","color":"light_purple"}'},Cookie:1b,CustomModelData:1}
execute as @a[nbt={Inventory:[{Slot:-106b,tag:{Cookie:1b}}]}] unless data entity @s Inventory[{Slot:-106b}].tag.ChargedProjectiles[] run replaceitem entity @s weapon.offhand crossbow{ChargedProjectiles:[{id:"firework_rocket",Count:1b,tag:{Cookie:1b,CustomModelData:1}}],Charged:1b,display:{Name:'{"text":"Cookie Blaster","italic":"false","color":"light_purple"}'},Cookie:1b,CustomModelData:1}
    
execute as @a[scores={IdeaCookieUse=1..},nbt={SelectedItem:{tag:{Cookie:1b}}}] at @s anchored eyes run function 8_ideas:cookie/cookie
kill @e[type=item,tag=cookie,nbt={Age:200s}]